/* ***********************************************************************/
/*                                                                       */
/*                      WiNRADiO G35DDC Excalibur Ultra                  */
/*      Compat ioctl codes and definitions for G35DDC device driver      */
/*                     (C) Copyright 2014 RADIXON.                       */
/*                                                                       */
/* ***********************************************************************/

#ifndef __G35_IOCTL_COMPAT_H__
#define __G35_IOCTL_COMPAT_H__

#ifdef CONFIG_COMPAT

#pragma pack(push,1)

struct g35_fpga_data_compat
{
    compat_uptr_t   buffer;
    uint32_t        size;
};

struct g35_ddc1_start_params_compat
{
    uint32_t                buffer_size;
    uint32_t                bytes_per_sec;
    struct g35_ddc1_params  params;
    compat_uptr_t           coeffs;
    uint32_t				num_coeffs;
};

#pragma pack(pop)

#define G35_IOCTL_CONFIGURE_FPGA_COMPAT             _IOW(0x8C,0x03,struct g35_fpga_data_compat)

#define G35_IOCTL_IF_PUT_BUFFER_COMPAT              _IOW(0x8C,0x09,compat_uptr_t)
#define G35_IOCTL_IF_GET_BUFFER_COMPAT              _IOR(0x8C,0x0A,compat_uptr_t)

#define G35_IOCTL_DDC1_0_PREPARE_COMPAT             _IOW(0x8C,0x0C,struct g35_ddc1_start_params_compat)
#define G35_IOCTL_DDC1_0_PUT_BUFFER_COMPAT          _IOW(0x8C,0x0F,compat_uptr_t)
#define G35_IOCTL_DDC1_0_GET_BUFFER_COMPAT          _IOR(0x8C,0x10,compat_uptr_t)
#define G35_IOCTL_DDC1_1_PREPARE_COMPAT             _IOW(0x8C,0x11,struct g35_ddc1_start_params_compat)
#define G35_IOCTL_DDC1_1_PUT_BUFFER_COMPAT          _IOW(0x8C,0x14,compat_uptr_t)
#define G35_IOCTL_DDC1_1_GET_BUFFER_COMPAT          _IOR(0x8C,0x15,compat_uptr_t)

#define G35_IOCTL_SWP_PUT_BUFFER_COMPAT             _IOW(0x8C,0x2A,compat_uptr_t)
#define G35_IOCTL_SWP_GET_BUFFER_COMPAT             _IOR(0x8C,0x2B,compat_uptr_t)

#define G35_IOCTL_DDC_PLAYBACK_START_COMPAT          _IOW(0x8C,0x30,struct g35_ddc1_start_params_compat)
#define G35_IOCTL_DDC_PLAYBACK_PUT_BUFFER_IN_COMPAT  _IOW(0x8C,0x32,compat_uptr_t)
#define G35_IOCTL_DDC_PLAYBACK_GET_BUFFER_IN_COMPAT  _IOR(0x8C,0x33,compat_uptr_t)
#define G35_IOCTL_DDC_PLAYBACK_PUT_BUFFER_OUT_COMPAT _IOW(0x8C,0x34,compat_uptr_t)
#define G35_IOCTL_DDC_PLAYBACK_GET_BUFFER_OUT_COMPAT _IOR(0x8C,0x35,compat_uptr_t)

#define G35_IOCTL_DAC_PUT_BUFFER_COMPAT             _IOW(0x8C,0x40,compat_uptr_t)
#define G35_IOCTL_DAC_GET_BUFFER_COMPAT             _IOR(0x8C,0x41,compat_uptr_t)


#endif //CONFIG_COMPAT

#endif // __G35_IOCTL_COMPAT_H__
